Project Chrono: chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM Class Reference

Public Member Functions | Protected Attributes | List of all members
chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM Class Reference
Chrono::Engine » Finite Element Analysis » Utility classes

## Description

Utility class for creating complex beams using ChElementBeamTaperedTimoshenkoFPM elements, for example subdivides a segment in multiple finite elements.

`#include <ChBuilderBeam.h>`

## Public Member Functions
void | BuildBeam (std::shared_ptr< ChMesh > mesh, std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > sect, const int N, const ChVector3d A, const ChVector3d B, const ChVector3d Ydir)
| Add beam FEM elements to the mesh to create a segment beam from point A to point B, using ChElementBeamTaperedTimoshenkoFPM type elements.
void | BuildBeam (std::shared_ptr< ChMesh > mesh, std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > sect, const int N, std::shared_ptr< ChNodeFEAxyzrot > nodeA, std::shared_ptr< ChNodeFEAxyzrot > nodeB, const ChVector3d Ydir)
| Add beam FEM elements to the mesh to create a segment beam from one existing node to another existing node, using ChElementBeamTaperedTimoshenkoFPM type elements.
void | BuildBeam (std::shared_ptr< ChMesh > mesh, std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > sect, const int N, std::shared_ptr< ChNodeFEAxyzrot > nodeA, const ChVector3d B, const ChVector3d Ydir)
| Add beam FEM elements to the mesh to create a segment beam from one existing node to a point B, using ChElementBeamTaperedTimoshenkoFPM type elements.
std::vector< std::shared_ptr< ChElementBeamTaperedTimoshenkoFPM > > & | GetLastBeamElements ()
| Access the list of elements used by the last built beam.
std::vector< std::shared_ptr< ChNodeFEAxyzrot > > & | GetLastBeamNodes ()
| Access the list of nodes used by the last built beam.

## Protected Attributes
std::vector< std::shared_ptr< ChElementBeamTaperedTimoshenkoFPM > > | beam_elems
std::vector< std::shared_ptr< ChNodeFEAxyzrot > > | beam_nodes

## Member Function Documentation

## ◆ BuildBeam() [1/3]

void chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM::BuildBeam | ( | std::shared_ptr< ChMesh > | mesh,
|  | std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > | sect,
|  | const int | N,
|  | const ChVector3d | A,
|  | const ChVector3d | B,
|  | const ChVector3d | Ydir )

Add beam FEM elements to the mesh to create a segment beam from point A to point B, using ChElementBeamTaperedTimoshenkoFPM type elements.

Before running, each time resets lists of beam_elems and beam_nodes.

Parameters

  mesh | mesh to store the resulting elements
  sect | section material for beam elements
  N | number of elements in the segment
  A | starting point
  B | ending point
  Ydir | the 'up' Y direction of the beam

## ◆ BuildBeam() [2/3]

void chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM::BuildBeam | ( | std::shared_ptr< ChMesh > | mesh,
|  | std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > | sect,
|  | const int | N,
|  | std::shared_ptr< ChNodeFEAxyzrot > | nodeA,
|  | const ChVector3d | B,
|  | const ChVector3d | Ydir )

Add beam FEM elements to the mesh to create a segment beam from one existing node to a point B, using ChElementBeamTaperedTimoshenkoFPM type elements.

Before running, each time resets lists of beam_elems and beam_nodes.

Parameters

  mesh | mesh to store the resulting elements
  sect | section material for beam elements
  N | number of elements in the segment
  nodeA | starting point
  B | ending point
  Ydir | the 'up' Y direction of the beam

## ◆ BuildBeam() [3/3]

void chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM::BuildBeam | ( | std::shared_ptr< ChMesh > | mesh,
|  | std::shared_ptr< ChBeamSectionTaperedTimoshenkoAdvancedGenericFPM > | sect,
|  | const int | N,
|  | std::shared_ptr< ChNodeFEAxyzrot > | nodeA,
|  | std::shared_ptr< ChNodeFEAxyzrot > | nodeB,
|  | const ChVector3d | Ydir )

Add beam FEM elements to the mesh to create a segment beam from one existing node to another existing node, using ChElementBeamTaperedTimoshenkoFPM type elements.

Before running, each time resets lists of beam_elems and beam_nodes.

Parameters

  mesh | mesh to store the resulting elements
  sect | section material for beam elements
  N | number of elements in the segment
  nodeA | starting point
  nodeB | ending point
  Ydir | the 'up' Y direction of the beam

## ◆ GetLastBeamElements()

std::vector< std::shared_ptr< ChElementBeamTaperedTimoshenkoFPM > > & chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM::GetLastBeamElements | ( |  | ) |
| inline

Access the list of elements used by the last built beam.

It can be useful for changing properties afterwards. This list is reset all times a BuildBeam function is called.

## ◆ GetLastBeamNodes()

std::vector< std::shared_ptr< ChNodeFEAxyzrot > > & chrono::fea::ChBuilderBeamTaperedTimoshenkoFPM::GetLastBeamNodes | ( |  | ) |
| inline

Access the list of nodes used by the last built beam.

It can be useful for adding constraints or changing properties afterwards. This list is reset all times a BuildBeam function is called.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChBuilderBeam.h
- D:/W/B/src/chrono-9.0.1/src/chrono/fea/ChBuilderBeam.cpp